﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace WcfRestSample
{   
    public class BookService : IBookService
    {
        public List<Books> GetBooksList()
        {
            using (SampleDbEntities entities = new SampleDbEntities())
            {
                return entities.Books.ToList();
            }
        }

        public Books GetBookById(string id)
        {
            try
            {
                int bookId = Convert.ToInt32(id);

                using (SampleDbEntities entities = new SampleDbEntities())
                {
                    return entities.Books.SingleOrDefault(book => book.ID == bookId);
                }
            }
            catch
            {
                throw new FaultException("Something went wrong");
            }
        }

        public void AddBook(string name)
        {
            using (SampleDbEntities entities = new SampleDbEntities())
            {
                Books book = new Books { BookName = name };
                entities.Books.Add(book);
                entities.SaveChanges();
            }
        }

        public void UpdateBook(string id, string name)
        {
            try
            {
                int bookId = Convert.ToInt32(id);

                using (SampleDbEntities entities = new SampleDbEntities())
                {
                    Books book = entities.Books.SingleOrDefault(b => b.ID == bookId);
                    book.BookName = name;
                    entities.SaveChanges();
                }
            }
            catch
            {
                throw new FaultException("Something went wrong");
            }
        }

        public void DeleteBook(string id)
        {
            try
            {
                int bookId = Convert.ToInt32(id);

                using (SampleDbEntities entities = new SampleDbEntities())
                {
                    Books book = entities.Books.SingleOrDefault(b => b.ID == bookId);
                    entities.Books.Remove(book);
                    entities.SaveChanges();
                }
            }
            catch
            {
                throw new FaultException("Something went wrong");
            }
        }

        public List<string> GetBooksNames()
        {
            using (SampleDbEntities entities = new SampleDbEntities())
            {
                return entities.Books.Select(book => book.BookName).ToList();
            }
        }
    }
}
